#!/usr/bin/perl

while ($f = shift) {
  $b = $f;
  $b =~ s|\.html|.oml|;
  print "Convert $f => $b .";
  open IF, "$f";
  $/ = "";
  
  $l = "";
  $_ = "";

  while ($k = <IF>) {
    $l = $l . $k;
  }
  @FOO = split /<hr>/, $l;
  
  $head = shift @FOO;
  @BAR = split /<title>/, $head;
  $head = shift @BAR;
  pop @FOO;
  $_ = pop @FOO;
  if (! m|^<p><center>.*\|.*\|.*</center></p>|) {
    @FOO = (@FOO, $_);
  }
  $m = "";
  while ($l = shift @FOO) {
    $m = $l;
  }
  $_ = "$head\n>\n$m";
#  print $_;
  s|<html><head>|<opaldoc |;
  s|<meta name=\"BASURI\" content=\"([^\"]*)\">||;
  s|<meta name=\"PROJECTID\" content=\"([^\"]*)\">||;
  s|<meta name=\"RELURI\" content=\"([^\"]*)\">||;
  s|<meta name=\"DATABASE\" content=\"([^\"]*)\">||;
  s|<meta name=\"FILESID\" content=\"\d+\">||;
  s|<meta name=\"TITLE\" content=\"([^\"]*)\">|title=\"$1\"|;
  s|<meta name=\"DESCRIPTION\" content=\"([^\"]*)\">|description=\"$1\"|;
  s|<meta name=\"LANGUAGE\" content=\"([^\"]*)\">|language=\"$1\"|;
  s|<meta name=\"DATE\" content=\"([^\"]*)\">|date=\"$1\"|;
  s|<meta name=\"KEYWORDS\" content=\"([^\"]*)\">||;
  
  print ".";
  # Body
  s|<BODY[^>]*>||;
  
  print ".";
  @FOO = split /<\/[tT][aA][bB][lL][eE]>/, $_;
  $k = "";
  while ($_ = shift @FOO) {
    # Descriptionlist
    if (m|<TABLE width=100%>|) {
      $_ = $_ . "</descriptionlist>\n";
    }
    s|<TR><TD valign=top><B>([^<]*)</B></TD><TD valign=top>([^<]*)</TD></TR>|<item title=\"$1\">$2</item>|g;
    s|<TABLE width=100\%>\s+<item|<descriptionlist>\n<item|g;

    # Index
    if (m|<table witdh=100\% align=center>|) {
      $_ = $_ . "</index>\n";
    }
    s|<tr><td valign=top align=center width=17\%>\s+<a href=\"([\w\d\/\._-]*)\"><b>([^\<]*)</b></a>\s+</td>\s+<td valign=top align=center width=23\%>\s*([^<]*)\s*</td><td width=6\%> \&nbsp; </td>|<item uri=\"$1\" title=\"$2\">$3</item>|gi;
    s|<tr><td valign=top align=center width=17\%>\s*<b>([^\<]*)</b>\s*</td>\s+<td valign=top align=center width=23\%>\s*([^<]*)\s*</td><td width=6\%> \&nbsp; </td>|<item title=\"$1\">$2</item>|gi;
    s|<tr><td valign=top align=center width=17\%>\s+</td>\s+<td valign=top align=center width=23\%>\s*([^<]*)\s*</td><td width=6\%> \&nbsp; </td>|<item>$1</item>|gi;
    s|<td valign=top align=center width=17\%>\s+<a href=\"([\w\d\/\._-]*)\"><b>([^\<]*)</b></a>\s+</td>\s+<td valign=top align=center width=23\%>\n([^<]*)\s*</td></tr>|<item uri=\"$1\" title=\"$2\">$3</item>|gi;
    s|<td valign=top align=center width=17\%>\s*<b>([^\<]*)</b>\s*</td>\s+<td valign=top align=center width=23\%>\n([^<]*)\s*</td></tr>|<item title=\"$1\">$2</item>|gi;
    s|<td valign=top align=center width=17\%>\s+</td>\+<td valign=top align=center width=23\%>\n([^<]*)\s*</td></tr>|<item>$1</item>|gi;
    s|<table witdh=100% align=center>\s+<item|<index>\n<item|gi;
    $k = $k . $_;
  }
  $_ = $k;

  # Fix
  s|<td> \&nbsp; </td><td> \&nbsp; </td></tr>||g;
  s|\&nbsp;| |g;

  # Chapters
  s|<h\d>[\d\.]+\s*\&nbsp;\s*([^>]*)\s*</h\d>\s*<BLOCKQUOTE>|<chapter title=\"$1\">\n|g;
  s|<h\d>[\d\.]+\s*([^>]*)\s*</h\d>\s*<BLOCKQUOTE>|<chapter title=\"$1\">\n|g;
  s|</BLOCKQUOTE>|</chapter>|g;
  print ".";
  # Logg
  s|<!-- LOGG date=(\w+) author=(\w+)\s+([^>]+)\s+-->|<logg date=\"$1\" author=\"$2\">\n$3</logg>|g;

  # .html -> .oml
  s|\.html|\.oml|g;

  # BR
  s|<BR>|<br/>|g;

  # End
  s|<hr><p><center>.*$||;
  
  print ".";
  s|\n+|\n|g;
  print ".";
  
  $t = "$_\n</opaldoc>\n";
  print ".";
  
  close (IF);
  open OF, ">$b";
  print ".";
  print OF $t;
  print ".";
  close OF;
  print ".";
  print " done!\n";
}
